/[gentoo-x86]/eclass/vdr-plugin.eclass
Gentoo

Diff of /eclass/vdr-plugin.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.48 Revision 1.79
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/Attic/vdr-plugin.eclass,v 1.48 2007/08/14 18:42:22 zzam Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/Attic/vdr-plugin.eclass,v 1.79 2012/01/15 20:54:56 idl0r Exp $
4# 4
5# @ECLASS: vdr-plugin.eclass
6# @MAINTAINER:
7# vdr@gentoo.org
8# @BLURB: common vdr plugin ebuild functions
9# @DESCRIPTION:
10# Eclass for easing maitenance of vdr plugin ebuilds
11
5# Author: 12# Author:
6# Matthias Schwarzott <zzam@gentoo.org> 13# Matthias Schwarzott <zzam@gentoo.org>
7# Joerg Bornkessel <hd_brummy@gentoo.org> 14# Joerg Bornkessel <hd_brummy@gentoo.org>
8 15
9# vdr-plugin.eclass 16# Example ebuild (basic version without patching):
10# 17#
11# eclass to create ebuilds for vdr plugins 18# EAPI="2"
12#
13
14# Example ebuild (vdr-femon):
15#
16# inherit vdr-plugin 19# inherit vdr-plugin
17# IUSE="" 20# IUSE=""
18# SLOT="0" 21# SLOT="0"
19# DESCRIPTION="vdr Plugin: DVB Frontend Status Monitor (signal strengt/noise)" 22# DESCRIPTION="vdr Plugin: DVB Frontend Status Monitor (signal strengt/noise)"
20# HOMEPAGE="http://www.saunalahti.fi/~rahrenbe/vdr/femon/" 23# HOMEPAGE="http://www.saunalahti.fi/~rahrenbe/vdr/femon/"
21# SRC_URI="http://www.saunalahti.fi/~rahrenbe/vdr/femon/files/${P}.tgz" 24# SRC_URI="http://www.saunalahti.fi/~rahrenbe/vdr/femon/files/${P}.tgz"
22# LICENSE="GPL-2" 25# LICENSE="GPL-2"
23# KEYWORDS="~x86" 26# KEYWORDS="~x86"
24# DEPEND=">=media-video/vdr-1.3.27" 27# DEPEND=">=media-video/vdr-1.6.0"
25# 28#
26# 29#
30
31# For patching you should modify src_prepare phase:
32#
33# src_prepare() {
34# epatch "${FILESDIR}"/${P}-xxx.patch
35# vdr-plugin_src_prepare
36# }
27 37
28# Installation of a config file for the plugin 38# Installation of a config file for the plugin
29# 39#
30# If ${VDR_CONFD_FILE} is set install this file 40# If ${VDR_CONFD_FILE} is set install this file
31# else install ${FILESDIR}/confd if it exists. 41# else install ${FILESDIR}/confd if it exists.
57# 67#
58# all patches which ending on diff or patch in this DIR will automatically applied 68# all patches which ending on diff or patch in this DIR will automatically applied
59# 69#
60 70
61inherit base multilib eutils flag-o-matic 71inherit base multilib eutils flag-o-matic
72
73if ! has "${EAPI:-0}" 0 1 2 3 4; then
74 die "API of vdr-plugin.eclass in EAPI=\"${EAPI}\" not established"
75fi
62 76
63IUSE="" 77IUSE=""
64 78
65# Name of the plugin stripped from all vdrplugin-, vdr- and -cvs pre- and postfixes 79# Name of the plugin stripped from all vdrplugin-, vdr- and -cvs pre- and postfixes
66VDRPLUGIN="${PN/#vdrplugin-/}" 80VDRPLUGIN="${PN/#vdrplugin-/}"
71 85
72# works in most cases 86# works in most cases
73S="${WORKDIR}/${VDRPLUGIN}-${PV}" 87S="${WORKDIR}/${VDRPLUGIN}-${PV}"
74 88
75# depend on headers for DVB-driver 89# depend on headers for DVB-driver
76RDEPEND=">=media-tv/gentoo-vdr-scripts-0.3.4-r1" 90COMMON_DEPEND=">=media-tv/gentoo-vdr-scripts-0.4.2"
91
92DEPEND="${COMMON_DEPEND}
77DEPEND="media-tv/linuxtv-dvb-headers" 93 media-tv/linuxtv-dvb-headers"
94RDEPEND="${COMMON_DEPEND}
95 >=app-admin/eselect-vdr-0.0.2"
78 96
79 97# this is a hack for ebuilds like vdr-xineliboutput that want to
80# this code is from linux-mod.eclass 98# conditionally install a vdr-plugin
81update_vdrplugindb() { 99if [[ "${GENTOO_VDR_CONDITIONAL:-no}" = "yes" ]]; then
82 local VDRPLUGINDB_DIR=${ROOT}/var/lib/vdrplugin-rebuild/ 100 # make DEPEND conditional
83 101 IUSE="${IUSE} vdr"
84 if [[ ! -f ${VDRPLUGINDB_DIR}/vdrplugindb ]]; then 102 DEPEND="vdr? ( ${DEPEND} )"
85 [[ ! -d ${VDRPLUGINDB_DIR} ]] && mkdir -p ${VDRPLUGINDB_DIR} 103 RDEPEND="vdr? ( ${RDEPEND} )"
86 touch ${VDRPLUGINDB_DIR}/vdrplugindb
87 fi 104fi
88 if [[ -z $(grep ${CATEGORY}/${PN}-${PVR} ${VDRPLUGINDB_DIR}/vdrplugindb) ]]; then
89 einfo "Adding plugin to vdrplugindb."
90 echo "a:1:${CATEGORY}/${PN}-${PVR}" >> ${VDRPLUGINDB_DIR}/vdrplugindb
91 fi
92}
93
94remove_vdrplugindb() {
95 local VDRPLUGINDB_DIR=${ROOT}/var/lib/vdrplugin-rebuild/
96
97 if [[ -n $(grep ${CATEGORY}/${PN}-${PVR} ${VDRPLUGINDB_DIR}/vdrplugindb) ]]; then
98 einfo "Removing ${CATEGORY}/${PN}-${PVR} from vdrplugindb."
99 sed -ie "/.*${CATEGORY}\/${P}.*/d" ${VDRPLUGINDB_DIR}/vdrplugindb
100 fi
101}
102 105
103# New method of storing plugindb 106# New method of storing plugindb
104# Called from src_install 107# Called from src_install
105# file maintained by normal portage-methods 108# file maintained by normal portage-methods
106create_plugindb_file() { 109create_plugindb_file() {
107 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/ 110 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/
108 local DB_FILE=${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF} 111 local DB_FILE="${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF}"
109 insinto ${NEW_VDRPLUGINDB_DIR} 112 insinto "${NEW_VDRPLUGINDB_DIR}"
113
114# BUG: portage-2.1.4_rc9 will delete the EBUILD= line, so we cannot use this code.
110 cat <<-EOT > ${D}/${DB_FILE} 115# cat <<-EOT > "${D}/${DB_FILE}"
111 VDRPLUGIN_DB=1 116# VDRPLUGIN_DB=1
112 CREATOR=ECLASS 117# CREATOR=ECLASS
113 EBUILD=${CATEGORY}/${PN} 118# EBUILD=${CATEGORY}/${PN}
114 EBUILD_V=${PVR} 119# EBUILD_V=${PVR}
115 EOT 120# EOT
121 {
122 echo "VDRPLUGIN_DB=1"
123 echo "CREATOR=ECLASS"
124 echo "EBUILD=${CATEGORY}/${PN}"
125 echo "EBUILD_V=${PVR}"
126 echo "PLUGINS=\"$@\""
127 } > "${D}/${DB_FILE}"
116} 128}
117 129
118# Delete files created outside of vdr-plugin.eclass 130# Delete files created outside of vdr-plugin.eclass
119# vdrplugin-rebuild.ebuild converted plugindb and files are 131# vdrplugin-rebuild.ebuild converted plugindb and files are
120# not deleted by portage itself - should only be needed as 132# not deleted by portage itself - should only be needed as
121# long as not every system has switched over to 133# long as not every system has switched over to
122# vdrplugin-rebuild-0.2 134# vdrplugin-rebuild-0.2 / gentoo-vdr-scripts-0.4.2
123delete_orphan_plugindb_file() { 135delete_orphan_plugindb_file() {
124 #elog Testing for orphaned plugindb file 136 #elog Testing for orphaned plugindb file
125 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/ 137 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/
126 local DB_FILE=${ROOT}/${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF} 138 local DB_FILE="${ROOT}/${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF}"
127 139
128 # file exists 140 # file exists
129 [[ -f ${DB_FILE} ]] || return 141 [[ -f ${DB_FILE} ]] || return
130 142
131 # will portage handle the file itself 143 # will portage handle the file itself
132 if grep -q CREATOR=ECLASS ${DB_FILE}; then 144 if grep -q CREATOR=ECLASS "${DB_FILE}"; then
133 #elog file owned by eclass - don't touch it 145 #elog file owned by eclass - don't touch it
134 return 146 return
135 fi 147 fi
136 148
137 elog "Removing orphaned plugindb-file." 149 elog "Removing orphaned plugindb-file."
138 elog "\t#rm ${DB_FILE}" 150 elog "\t#rm ${DB_FILE}"
139 rm ${DB_FILE} 151 rm "${DB_FILE}"
140} 152}
141 153
142 154
143create_header_checksum_file() 155create_header_checksum_file()
144{ 156{
145 # Danger: Not using $ROOT here, as compile will also not use it !!! 157 # Danger: Not using $ROOT here, as compile will also not use it !!!
146 # If vdr in $ROOT and / differ, plugins will not run anyway 158 # If vdr in $ROOT and / differ, plugins will not run anyway
147 159
148 insinto ${VDR_CHECKSUM_DIR} 160 local CHKSUM="header-md5-vdr"
161
149 if [[ -f ${VDR_CHECKSUM_DIR}/header-md5-vdr ]]; then 162 if [[ -f ${VDR_CHECKSUM_DIR}/header-md5-vdr ]]; then
150 newins ${VDR_CHECKSUM_DIR}/header-md5-vdr header-md5-${PN} 163 cp "${VDR_CHECKSUM_DIR}/header-md5-vdr" "${CHKSUM}"
164 elif type -p md5sum >/dev/null 2>&1; then
165 (
166 cd "${VDR_INCLUDE_DIR}"
167 md5sum *.h libsi/*.h|LC_ALL=C sort --key=2
168 ) > "${CHKSUM}"
151 else 169 else
152 if type -p md5sum >/dev/null 2>&1; then 170 die "Could not create md5 checksum of headers"
153 cd ${S} 171 fi
154 ( 172
155 cd ${VDR_INCLUDE_DIR} 173 insinto "${VDR_CHECKSUM_DIR}"
156 md5sum *.h libsi/*.h|LC_ALL=C sort --key=2 174 local p_name
157 ) > header-md5-${PN} 175 for p_name; do
158 doins header-md5-${PN} 176 newins "${CHKSUM}" "header-md5-${p_name}"
177 done
178}
179
180fix_vdr_libsi_include()
181{
182 #einfo "Fixing include of libsi-headers"
183 local f
184 for f; do
185 sed -i "${f}" \
186 -e '/#include/s:"\(.*libsi.*\)":<\1>:' \
187 -e '/#include/s:<.*\(libsi/.*\)>:<vdr/\1>:'
188 done
189}
190
191vdr_patchmakefile() {
192 einfo "Patching Makefile"
193 [[ -e Makefile ]] || die "Makefile of plugin can not be found!"
194 cp Makefile "${WORKDIR}"/Makefile.before
195
196 # plugin makefiles use VDRDIR in strange ways
197 # assumptions:
198 # 1. $(VDRDIR) contains Make.config
199 # 2. $(VDRDIR) contains config.h
200 # 3. $(VDRDIR)/include/vdr contains the headers
201 # 4. $(VDRDIR) contains main vdr Makefile
202 # 5. $(VDRDIR)/locale exists
203 # 6. $(VDRDIR) allows to access vdr source files
204 #
205 # We only have one directory (for now /usr/include/vdr),
206 # that contains vdr-headers and Make.config.
207 # To satisfy 1-3 we do this:
208 # Set VDRDIR=/usr/include/vdr
209 # Set VDRINCDIR=/usr/include
210 # Change $(VDRDIR)/include to $(VDRINCDIR)
211
212 sed -i Makefile \
213 -e "s:^VDRDIR.*$:VDRDIR = ${VDR_INCLUDE_DIR}:" \
214 -e "/^VDRDIR/a VDRINCDIR = ${VDR_INCLUDE_DIR%/vdr}" \
215 -e '/VDRINCDIR.*=/!s:$(VDRDIR)/include:$(VDRINCDIR):' \
216 \
217 -e 's:-I$(DVBDIR)/include::' \
218 -e 's:-I$(DVBDIR)::'
219
220 # maybe needed for multiproto:
221 #sed -i Makefile \
222 # -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
223 # -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):'
224
225 if ! grep -q APIVERSION Makefile; then
226 ebegin " Converting to APIVERSION"
227 sed -i Makefile \
228 -e 's:^APIVERSION = :APIVERSION ?= :' \
229 -e 's:$(LIBDIR)/$@.$(VDRVERSION):$(LIBDIR)/$@.$(APIVERSION):' \
230 -e '/VDRVERSION =/a\APIVERSION = $(shell sed -ne '"'"'/define APIVERSION/s/^.*"\\(.*\\)".*$$/\\1/p'"'"' $(VDRDIR)/config.h)'
231 eend $?
232 fi
233
234 # Correcting Compile-Flags
235 # Do not overwrite CXXFLAGS, add LDFLAGS if missing
236 sed -i Makefile \
237 -e '/^CXXFLAGS[[:space:]]*=/s/=/?=/' \
238 -e '/LDFLAGS/!s:-shared:$(LDFLAGS) -shared:'
239
240 # Disabling file stripping, useful for debugging
241 sed -i Makefile \
242 -e '/@.*strip/d' \
243 -e '/strip \$(LIBDIR)\/\$@/d' \
244 -e 's/STRIP.*=.*$/STRIP = true/'
245
246 # Use a file instead of a variable as single-stepping via ebuild
247 # destroys environment.
248 touch "${WORKDIR}"/.vdr-plugin_makefile_patched
249}
250
251vdr_add_local_patch() {
252 if test -d "${VDR_LOCAL_PATCHES_DIR}/${PN}"; then
253 echo
254 einfo "Applying local patches"
255 for LOCALPATCH in "${VDR_LOCAL_PATCHES_DIR}/${PN}/${PV}"/*.{diff,patch}; do
256 test -f "${LOCALPATCH}" && epatch "${LOCALPATCH}"
257 done
258 fi
259}
260
261vdr_has_gettext() {
262 has_version ">=media-video/vdr-1.5.7"
263}
264
265plugin_has_gettext() {
266 [[ -d po ]]
267}
268
269vdr_i18n_convert_to_gettext() {
270 if has_version ">=media-video/vdr-1.7.22"; then
271 local i18n_tool="${ROOT}/usr/share/vdr/bin/i18n-to-gettext"
272 else
273 local i18n_tool="${ROOT}/usr/share/vdr/bin/i18n-to-gettext.pl"
274 fi
275
276 if [[ ${NO_GETTEXT_HACK} == "1" ]]; then
277 ewarn "Conversion to gettext disabled in ebuild"
278 return 1
279 fi
280
281 if [[ ! -x ${i18n_tool} ]]; then
282 eerror "Missing ${i18n_tool}"
283 eerror "Please re-emerge vdr"
284 die "Missing ${i18n_tool}"
285 fi
286
287 ebegin "Auto converting translations to gettext"
288 # call i18n-to-gettext tool
289 # take all texts missing tr call into special file
290 "${i18n_tool}" 2>/dev/null \
291 |sed -e '/^"/!d' \
292 -e '/^""$/d' \
293 -e 's/\(.*\)/trNOOP(\1)/' \
294 > dummy-translations-trNOOP.c
295
296 # if there were untranslated texts just run it again
297 # now the missing calls are listed in
298 # dummy-translations-trNOOP.c
299 if [[ -s dummy-translations-trNOOP.c ]]; then
300 "${i18n_tool}" &>/dev/null
301 fi
302
303 # now use the modified Makefile
304 if [[ -f Makefile.new ]]; then
305 mv Makefile.new Makefile
306 eend 0 ""
307 else
308 eend 1 "Conversion to gettext failed. Plugin needs fixing."
309 return 1
310 fi
311}
312
313vdr_i18n_disable_gettext() {
314 #einfo "Disabling gettext support in plugin"
315
316 # Remove i18n Target if using older vdr
317 sed -i Makefile \
318 -e '/^all:/s/ i18n//'
319}
320
321vdr_i18n() {
322 if vdr_has_gettext; then
323 #einfo "VDR has gettext support"
324 if plugin_has_gettext; then
325 #einfo "Plugin has gettext support, fine"
326 if [[ ${NO_GETTEXT_HACK} == "1" ]]; then
327 ewarn "Please remove unneeded NO_GETTEXT_HACK from ebuild."
328 fi
329 else
330 vdr_i18n_convert_to_gettext
331 if [[ $? != 0 ]]; then
332 eerror ""
333 eerror "Plugin will have only english OSD texts"
334 eerror "it needs manual fixing."
335 fi
159 fi 336 fi
337 else
338 #einfo "VDR has no gettext support"
339 if plugin_has_gettext; then
340 vdr_i18n_disable_gettext
160 fi 341 fi
342 fi
161} 343}
344
345vdr-plugin_copy_source_tree() {
346 pushd . >/dev/null
347 cp -r "${S}" "${T}"/source-tree
348 cd "${T}"/source-tree
349 cp "${WORKDIR}"/Makefile.before Makefile
350 # TODO: Fix this, maybe no longer needed
351 sed -i Makefile \
352 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
353 -e 's:^CXXFLAGS:#CXXFLAGS:' \
354 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):' \
355 -e 's:-I$(VDRDIR) -I$(DVBDIR):-I$(DVBDIR) -I$(VDRDIR):'
356 popd >/dev/null
357}
358
359vdr-plugin_install_source_tree() {
360 einfo "Installing sources"
361 destdir="${VDRSOURCE_DIR}/vdr-${VDRVERSION}/PLUGINS/src/${VDRPLUGIN}"
362 insinto "${destdir}-${PV}"
363 doins -r "${T}"/source-tree/*
364
365 dosym "${VDRPLUGIN}-${PV}" "${destdir}"
366}
367
368vdr-plugin_print_enable_command() {
369 local p_name c=0 l=""
370 for p_name in ${vdr_plugin_list}; do
371 c=$(( c+1 ))
372 l="$l ${p_name#vdr-}"
373 done
374
375 elog
376 case $c in
377 1) elog "Installed plugin${l}" ;;
378 *) elog "Installed $c plugins:${l}" ;;
379 esac
380 elog "To activate a plugin execute this command:"
381 elog "\teselect vdr-plugin enable <plugin_name> ..."
382 elog
383}
384
385has_vdr() {
386 [[ -f "${VDR_INCLUDE_DIR}"/config.h ]]
387}
388
389## exported functions
162 390
163vdr-plugin_pkg_setup() { 391vdr-plugin_pkg_setup() {
164 # -fPIC is needed for shared objects on some platforms (amd64 and others) 392 # -fPIC is needed for shared objects on some platforms (amd64 and others)
165 append-flags -fPIC 393 append-flags -fPIC
166 394
395 # Plugins need to be compiled with position independent code, otherwise linking
396 # VDR against it will fail
397 if has_version ">=media-video/vdr-1.7.13"; then
398 append-flags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE
399 fi
400
167 # Where should the plugins live in the filesystem 401 # Where should the plugins live in the filesystem
168 VDR_PLUGIN_DIR="/usr/$(get_libdir)/vdr/plugins" 402 VDR_PLUGIN_DIR="/usr/$(get_libdir)/vdr/plugins"
169 VDR_CHECKSUM_DIR="${VDR_PLUGIN_DIR%/plugins}/checksums" 403 VDR_CHECKSUM_DIR="${VDR_PLUGIN_DIR%/plugins}/checksums"
170 404
171 # was /usr/lib/... some time ago 405 # was /usr/lib/... some time ago
174 408
175 # Pathes to includes 409 # Pathes to includes
176 VDR_INCLUDE_DIR="/usr/include/vdr" 410 VDR_INCLUDE_DIR="/usr/include/vdr"
177 DVB_INCLUDE_DIR="/usr/include" 411 DVB_INCLUDE_DIR="/usr/include"
178 412
179
180 TMP_LOCALE_DIR="${WORKDIR}/tmp-locale" 413 TMP_LOCALE_DIR="${WORKDIR}/tmp-locale"
181 LOCDIR="/usr/share/vdr/locale"
182 if has_version ">=media-video/vdr-1.5.7"; then 414 if has_version ">=media-video/vdr-1.6.0_p2-r7"; then
183 USE_GETTEXT=1 415 LOCDIR="/usr/share/locale"
184 else 416 else
185 USE_GETTEXT=0 417 LOCDIR="/usr/share/vdr/locale"
418 fi
419
420 if ! has_vdr; then
421 # set to invalid values to detect abuses
422 VDRVERSION="eclass_no_vdr_installed"
423 APIVERSION="eclass_no_vdr_installed"
424
425 if [[ "${GENTOO_VDR_CONDITIONAL:-no}" = "yes" ]] && ! use vdr; then
426 einfo "VDR not found!"
427 else
428 # if vdr is required
429 die "VDR not found!"
186 fi 430 fi
431 return
432 fi
187 433
188 VDRVERSION=$(awk -F'"' '/define VDRVERSION/ {print $2}' ${VDR_INCLUDE_DIR}/config.h) 434 VDRVERSION=$(awk -F'"' '/define VDRVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h)
189 APIVERSION=$(awk -F'"' '/define APIVERSION/ {print $2}' ${VDR_INCLUDE_DIR}/config.h) 435 APIVERSION=$(awk -F'"' '/define APIVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h)
190 [[ -z ${APIVERSION} ]] && APIVERSION="${VDRVERSION}" 436 [[ -z ${APIVERSION} ]] && APIVERSION="${VDRVERSION}"
191 437
192 einfo "Building ${PF} against vdr-${VDRVERSION}" 438 einfo "Compiling against"
193 einfo "APIVERSION: ${APIVERSION}" 439 einfo "\tvdr-${VDRVERSION} [API version ${APIVERSION}]"
440}
441
442vdr-plugin_src_util() {
443
444 while [ "$1" ]; do
445
446 case "$1" in
447 all)
448 vdr-plugin_src_util unpack add_local_patch patchmakefile i18n
449 ;;
450 prepare|all_but_unpack)
451 vdr-plugin_src_util add_local_patch patchmakefile i18n
452 ;;
453 unpack)
454 base_src_unpack
455 ;;
456 add_local_patch)
457 cd "${S}" || die "Could not change to plugin-source-directory!"
458 vdr_add_local_patch
459 ;;
460 patchmakefile)
461 cd "${S}" || die "Could not change to plugin-source-directory!"
462 vdr_patchmakefile
463 ;;
464 i18n)
465 cd "${S}" || die "Could not change to plugin-source-directory!"
466 vdr_i18n
467 ;;
468 esac
469
470 shift
471 done
194} 472}
195 473
196vdr-plugin_src_unpack() { 474vdr-plugin_src_unpack() {
197 if [[ -z ${VDR_INCLUDE_DIR} ]]; then 475 if [[ -z ${VDR_INCLUDE_DIR} ]]; then
198 eerror "Wrong use of vdr-plugin.eclass." 476 eerror "Wrong use of vdr-plugin.eclass."
199 eerror "An ebuild for a vdr-plugin will not work without calling vdr-plugin_pkg_setup." 477 eerror "An ebuild for a vdr-plugin will not work without calling vdr-plugin_pkg_setup."
200 echo 478 echo
201 eerror "Please report this at bugs.gentoo.org." 479 eerror "Please report this at bugs.gentoo.org."
202 die "vdr-plugin_pkg_setup not called!" 480 die "vdr-plugin_pkg_setup not called!"
203 fi 481 fi
204 [ -z "$1" ] && vdr-plugin_src_unpack unpack add_local_patch patchmakefile i18n 482 if [ -z "$1" ]; then
483 case "${EAPI:-0}" in
484 2|3|4)
485 vdr-plugin_src_util unpack
486 ;;
487 *)
488 vdr-plugin_src_util all
489 ;;
490 esac
491
492 else
493 vdr-plugin_src_util $@
494 fi
495}
496
497vdr-plugin_src_prepare() {
498 base_src_prepare
499 vdr-plugin_src_util prepare
500}
501
502vdr-plugin_src_compile() {
503 [ -z "$1" ] && vdr-plugin_src_compile copy_source compile
205 504
206 while [ "$1" ]; do 505 while [ "$1" ]; do
207 506
208 case "$1" in 507 case "$1" in
209 all_but_unpack) 508 copy_source)
210 vdr-plugin_src_unpack add_local_patch patchmakefile i18n
211 ;;
212 unpack)
213 base_src_unpack
214 ;;
215 patchmakefile)
216 if ! cd ${S}; then
217 ewarn "There seems to be no plugin-directory with the name ${S##*/}"
218 ewarn "Perhaps you find one among these:"
219 cd "${WORKDIR}"
220 ewarn "$(/bin/ls -1 ${WORKDIR})"
221 die "Could not change to plugin-source-directory!"
222 fi
223
224 einfo "Patching Makefile"
225 [[ -e Makefile ]] || die "Makefile of plugin can not be found!"
226 cp Makefile "${WORKDIR}"/Makefile.before
227
228 sed -i Makefile \
229 -e '1i\#Makefile was patched by vdr-plugin.eclass'
230
231 ebegin " Setting Pathes"
232 sed -i Makefile \
233 -e "s:^VDRDIR.*$:VDRDIR = ${VDR_INCLUDE_DIR}:" \
234 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
235 -e "s:^LIBDIR.*$:LIBDIR = ${S}:" \
236 -e "s:^TMPDIR.*$:TMPDIR = ${T}:" \
237 -e 's:-I$(VDRDIR)/include -I$(DVBDIR)/include:-I$(DVBDIR)/include -I$(VDRDIR)/include:' \
238 -e 's:-I$(VDRDIR)/include:-I'"${VDR_INCLUDE_DIR%vdr}"':' \
239 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):'
240 eend $?
241
242 ebegin " Converting to APIVERSION"
243 sed -i Makefile \
244 -e 's:^APIVERSION = :APIVERSION ?= :' \
245 -e 's:$(LIBDIR)/$@.$(VDRVERSION):$(LIBDIR)/$@.$(APIVERSION):' \
246 -e '2i\APIVERSION = '"${APIVERSION}"
247 eend $?
248
249 ebegin " Correcting Compile-Flags"
250 sed -i Makefile \
251 -e 's:^CXXFLAGS:#CXXFLAGS:' \
252 -e '/LDFLAGS/!s:-shared:$(LDFLAGS) -shared:'
253 eend $?
254
255 ebegin " Disabling file stripping"
256 sed -i Makefile \
257 -e '/@.*strip/d' \
258 -e '/strip \$(LIBDIR)\/\$@/d' \
259 -e '/^STRIP =/d' \
260 -e '/@.*\$(STRIP)/d'
261 eend $?
262
263 # Use a file instead of an variable as single-stepping via ebuild
264 # destroys environment.
265 touch ${WORKDIR}/.vdr-plugin_makefile_patched
266 ;;
267 add_local_patch)
268 cd ${S}
269 if test -d "${VDR_LOCAL_PATCHES_DIR}/${PN}"; then
270 echo
271 einfo "Applying local patches"
272 for LOCALPATCH in ${VDR_LOCAL_PATCHES_DIR}/${PN}/${PV}/*.{diff,patch}; do
273 test -f "${LOCALPATCH}" && epatch "${LOCALPATCH}"
274 done
275 fi
276 ;;
277 i18n)
278 cd ${S}
279 if [[ ${USE_GETTEXT} = 0 ]]; then
280 # Remove i18n Target if using older vdr
281 sed -i Makefile \
282 -e '/^all:/s/ i18n//'
283 elif [[ ${USE_GETTEXT} = 1 && ! -d po ]]; then
284 einfo "Converting translations to gettext"
285
286 local i18n_tool=/usr/share/vdr/bin/i18n-to-gettext.pl
287 if [[ ! -x ${i18n_tool} ]]; then
288 eerror "Missing ${i18n_tool}"
289 eerror "Please re-emerge vdr"
290 die "Missing ${i18n_tool}"
291 fi
292
293 # call i18n-to-gettext tool
294 # take all texts missing tr call into special file
295 ${i18n_tool} 2>/dev/null \
296 |sed -e '/^"/!d' \
297 -e '/^""$/d' \
298 -e 's/\(.*\)/trNOOP(\1)/' \
299 > dummy-translations-trNOOP.c
300
301 # if there were untranslated texts just run it again
302 # now the missing calls are listed in
303 # dummy-translations-trNOOP.c
304 if [[ -s dummy-translations-trNOOP.c ]]; then
305 ${i18n_tool} &>/dev/null
306 fi
307
308 # now use the modified Makefile
309 mv Makefile.new Makefile
310 fi
311 esac
312
313 shift
314 done
315}
316
317vdr-plugin_copy_source_tree() {
318 pushd . >/dev/null
319 cp -r ${S} ${T}/source-tree
320 cd ${T}/source-tree
321 cp "${WORKDIR}"/Makefile.before Makefile
322 sed -i Makefile \
323 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
324 -e 's:^CXXFLAGS:#CXXFLAGS:' \
325 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):' \
326 -e 's:-I$(VDRDIR) -I$(DVBDIR):-I$(DVBDIR) -I$(VDRDIR):'
327 popd >/dev/null
328}
329
330vdr-plugin_install_source_tree() {
331 einfo "Installing sources"
332 destdir=${VDRSOURCE_DIR}/vdr-${VDRVERSION}/PLUGINS/src/${VDRPLUGIN}
333 insinto ${destdir}-${PV}
334 doins -r ${T}/source-tree/*
335
336 dosym ${VDRPLUGIN}-${PV} ${destdir}
337}
338
339vdr-plugin_src_compile() {
340 [ -z "$1" ] && vdr-plugin_src_compile prepare compile
341
342 while [ "$1" ]; do
343
344 case "$1" in
345 prepare)
346 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_copy_source_tree 509 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_copy_source_tree
347 ;; 510 ;;
348 compile) 511 compile)
349 if [[ ! -f ${WORKDIR}/.vdr-plugin_makefile_patched ]]; then 512 if [[ ! -f ${WORKDIR}/.vdr-plugin_makefile_patched ]]; then
350 eerror "Wrong use of vdr-plugin.eclass." 513 eerror "Wrong use of vdr-plugin.eclass."
352 eerror "calling vdr-plugin_src_unpack to patch the Makefile." 515 eerror "calling vdr-plugin_src_unpack to patch the Makefile."
353 echo 516 echo
354 eerror "Please report this at bugs.gentoo.org." 517 eerror "Please report this at bugs.gentoo.org."
355 die "vdr-plugin_src_unpack not called!" 518 die "vdr-plugin_src_unpack not called!"
356 fi 519 fi
357 cd ${S} 520 cd "${S}"
521
522 BUILD_TARGETS=${BUILD_TARGETS:-${VDRPLUGIN_MAKE_TARGET:-all}}
358 523
359 emake ${BUILD_PARAMS} \ 524 emake ${BUILD_PARAMS} \
360 ${VDRPLUGIN_MAKE_TARGET:-all} \ 525 ${BUILD_TARGETS} \
361 LOCALEDIR="${TMP_LOCALE_DIR}" \ 526 LOCALEDIR="${TMP_LOCALE_DIR}" \
527 LIBDIR="${S}" \
528 TMPDIR="${T}" \
362 || die "emake failed" 529 || die "emake failed"
363 ;; 530 ;;
364 esac 531 esac
365 532
366 shift 533 shift
370vdr-plugin_src_install() { 537vdr-plugin_src_install() {
371 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_install_source_tree 538 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_install_source_tree
372 cd "${WORKDIR}" 539 cd "${WORKDIR}"
373 540
374 if [[ -n ${VDR_MAINTAINER_MODE} ]]; then 541 if [[ -n ${VDR_MAINTAINER_MODE} ]]; then
375 local mname=${P}-Makefile 542 local mname="${P}-Makefile"
376 cp "${S}"/Makefile ${mname}.patched 543 cp "${S}"/Makefile "${mname}.patched"
377 cp Makefile.before ${mname}.before 544 cp Makefile.before "${mname}.before"
378 545
379 diff -u ${mname}.before ${mname}.patched > ${mname}.diff 546 diff -u "${mname}.before" "${mname}.patched" > "${mname}.diff"
380 547
381 insinto "/usr/share/vdr/maintainer-data/makefile-changes" 548 insinto "/usr/share/vdr/maintainer-data/makefile-changes"
382 doins ${mname}.diff 549 doins "${mname}.diff"
383 550
384 insinto "/usr/share/vdr/maintainer-data/makefile-before" 551 insinto "/usr/share/vdr/maintainer-data/makefile-before"
385 doins ${mname}.before 552 doins "${mname}.before"
386 553
387 insinto "/usr/share/vdr/maintainer-data/makefile-patched" 554 insinto "/usr/share/vdr/maintainer-data/makefile-patched"
388 doins ${mname}.patched 555 doins "${mname}.patched"
389 556
390 fi 557 fi
558
559
391 560
392 cd "${S}" 561 cd "${S}"
393 insinto "${VDR_PLUGIN_DIR}" 562 insinto "${VDR_PLUGIN_DIR}"
394 doins libvdr-*.so.* 563 doins libvdr-*.so.*
395 564
396 if [[ ${USE_GETTEXT} = 1 && -d ${TMP_LOCALE_DIR} ]]; then 565 # create list of all created plugin libs
566 vdr_plugin_list=""
567 local p_name
568 for p in libvdr-*.so.*; do
569 p_name="${p%.so*}"
570 p_name="${p_name#lib}"
571 vdr_plugin_list="${vdr_plugin_list} ${p_name}"
572 done
573
574 create_header_checksum_file ${vdr_plugin_list}
575 create_plugindb_file ${vdr_plugin_list}
576
577 if vdr_has_gettext && [[ -d ${TMP_LOCALE_DIR} ]]; then
397 einfo "Installing locales" 578 einfo "Installing locales"
398 cd "${TMP_LOCALE_DIR}" 579 cd "${TMP_LOCALE_DIR}"
399 insinto "${LOCDIR}" 580 insinto "${LOCDIR}"
400 doins -r * 581 doins -r *
401 fi 582 fi
419 600
420 if [[ -n ${VDR_RCADDON_FILE} ]]; then 601 if [[ -n ${VDR_RCADDON_FILE} ]]; then
421 insinto "${VDR_RC_DIR}" 602 insinto "${VDR_RC_DIR}"
422 newins "${VDR_RCADDON_FILE}" plugin-${VDRPLUGIN}.sh 603 newins "${VDR_RCADDON_FILE}" plugin-${VDRPLUGIN}.sh
423 fi 604 fi
424
425 create_header_checksum_file
426 create_plugindb_file
427} 605}
428 606
429vdr-plugin_pkg_postinst() { 607vdr-plugin_pkg_postinst() {
430 if has_version "<=media-tv/vdrplugin-rebuild-0.1"; then 608 vdr-plugin_print_enable_command
431 update_vdrplugindb 609
432 fi
433 elog
434 elog "The vdr plugin ${VDRPLUGIN} has now been installed."
435 elog "To activate execute the following command:"
436 elog
437 elog " emerge --config ${PN}"
438 elog
439 if [[ -n "${VDR_CONFD_FILE}" ]]; then 610 if [[ -n "${VDR_CONFD_FILE}" ]]; then
440 elog "And have a look at the config-file" 611 elog "Please have a look at the config-file"
441 elog "/etc/conf.d/vdr.${VDRPLUGIN}" 612 elog "\t/etc/conf.d/vdr.${VDRPLUGIN}"
442 elog 613 elog
443 fi 614 fi
444} 615}
445 616
446vdr-plugin_pkg_postrm() { 617vdr-plugin_pkg_postrm() {
447 if has_version "<=media-tv/vdrplugin-rebuild-0.1"; then
448 remove_vdrplugindb
449 fi
450 delete_orphan_plugindb_file 618 delete_orphan_plugindb_file
451} 619}
452 620
453vdr-plugin_pkg_config_final() {
454 diff ${conf_orig} ${conf}
455 rm ${conf_orig}
456}
457
458vdr-plugin_pkg_config_old() {
459 elog "Using interface of gentoo-vdr-scripts-0.3.6 and older"
460 if [[ -z "${INSTALLPLUGIN}" ]]; then
461 INSTALLPLUGIN="${VDRPLUGIN}"
462 fi
463 # First test if plugin is already inside PLUGINS
464 local conf=/etc/conf.d/vdr
465 conf_orig=${conf}.before_emerge_config
466 cp ${conf} ${conf_orig}
467
468 elog "Reading ${conf}"
469 if ! grep -q "^PLUGINS=" ${conf}; then
470 local LINE=$(sed ${conf} -n -e '/^#.*PLUGINS=/=' | tail -n 1)
471 if [[ -n "${LINE}" ]]; then
472 sed -e ${LINE}'a PLUGINS=""' -i ${conf}
473 else
474 echo 'PLUGINS=""' >> ${conf}
475 fi
476 unset LINE
477 fi
478
479 unset PLUGINS
480 PLUGINS=$(source /etc/conf.d/vdr; echo ${PLUGINS})
481
482 active=0
483 for p in ${PLUGINS}; do
484 if [[ "${p}" == "${INSTALLPLUGIN}" ]]; then
485 active=1
486 break;
487 fi
488 done
489
490 if [[ "${active}" == "1" ]]; then
491 elog "${INSTALLPLUGIN} already activated"
492 echo
493 read -p "Do you want to deactivate ${INSTALLPLUGIN} (yes/no) " answer
494 if [[ "${answer}" != "yes" ]]; then
495 elog "aborted"
496 return
497 fi
498 elog "Removing ${INSTALLPLUGIN} from active plugins."
499 local LINE=$(sed ${conf} -n -e '/^PLUGINS=.*\<'${INSTALLPLUGIN}'\>/=' | tail -n 1)
500 sed -i ${conf} -e ${LINE}'s/\<'${INSTALLPLUGIN}'\>//' \
501 -e ${LINE}'s/ \( \)*/ /g' \
502 -e ${LINE}'s/ "/"/g' \
503 -e ${LINE}'s/" /"/g'
504
505 vdr-plugin_pkg_config_final
506 return
507 fi
508
509
510 elog "Adding ${INSTALLPLUGIN} to active plugins."
511 local LINE=$(sed ${conf} -n -e '/^PLUGINS=/=' | tail -n 1)
512 sed -i ${conf} -e ${LINE}'s/^PLUGINS=" *\(.*\)"/PLUGINS="\1 '${INSTALLPLUGIN}'"/' \
513 -e ${LINE}'s/ \( \)*/ /g' \
514 -e ${LINE}'s/ "/"/g' \
515 -e ${LINE}'s/" /"/g'
516
517 vdr-plugin_pkg_config_final
518}
519
520vdr-plugin_pkg_config_new() {
521 elog "Using interface introduced with gentoo-vdr-scripts-0.3.7"
522 if [[ -z "${INSTALLPLUGIN}" ]]; then
523 INSTALLPLUGIN="${VDRPLUGIN}"
524 fi
525
526 active=0
527 # First test if plugin is already inside PLUGINS
528 local conf=/etc/conf.d/vdr.plugins
529 exec 3<${conf}
530 while read -u 3 line; do
531 [[ ${line} == "" ]] && continue
532 [[ ${line:0:1} == "#" ]] && continue
533 set -- ${line}
534 [[ ${1} == ${INSTALLPLUGIN} ]] && active=1
535 done
536 exec 3<&-
537
538 if [[ $active == 0 ]]; then
539 elog "Adding ${INSTALLPLUGIN} to active plugins."
540
541 # The pure edit process.
542 echo "${INSTALLPLUGIN}" >> "${conf}"
543 else
544 elog "${INSTALLPLUGIN} already activated"
545 echo
546 read -p "Do you want to deactivate ${INSTALLPLUGIN} (yes/no) " answer
547 if [[ "${answer}" != "yes" ]]; then
548 elog "aborted"
549 return
550 fi
551 elog "Removing ${INSTALLPLUGIN} from active plugins."
552
553 # The pure edit process
554 sed -i "${conf}" -e "/^[[:space:]]*${INSTALLPLUGIN}[[:space:]]*\$/d"
555 fi
556}
557
558vdr-plugin_pkg_config() { 621vdr-plugin_pkg_config() {
559 if has_version ">media-tv/gentoo-vdr-scripts-0.3.6"; then 622 ewarn "emerge --config ${PN} is no longer supported"
560 vdr-plugin_pkg_config_new 623 vdr-plugin_print_enable_command
561 else
562 vdr-plugin_pkg_config_old
563 fi
564} 624}
565 625
566fix_vdr_libsi_include() 626case "${EAPI:-0}" in
567{ 627 2|3|4)
568 einfo "Fixing include of libsi-headers" 628 EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_compile src_install pkg_postinst pkg_postrm pkg_config
569 local f 629 ;;
570 for f; do 630 *)
571 sed -i "${f}" \
572 -e '/#include/s:"\(.*libsi.*\)":<\1>:' \
573 -e '/#include/s:<.*\(libsi/.*\)>:<vdr/\1>:'
574 done
575}
576
577EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postinst pkg_postrm pkg_config 631 EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postinst pkg_postrm pkg_config
632 ;;
633esac

Legend:
Removed from v.1.48  
changed lines
  Added in v.1.79

  ViewVC Help
Powered by ViewVC 1.1.20